﻿using System;
using System.Windows.Forms;

using DevExpress.XtraBars.Docking;
using DevExpress.XtraEditors;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : XtraForm
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 도킹 관리자
        /// </summary>
        private DockManager dockManager;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            this.dockManager = new DockManager(this);

            DockPanel panel1 = this.dockManager.AddPanel(DockingStyle.Top);

            panel1.Text = "Panel 1";

            PropertyGrid propertyGrid = new PropertyGrid();

            propertyGrid.SelectedObject = panel1;
            propertyGrid.Dock           = DockStyle.Fill;

            panel1.ControlContainer.Controls.Add(propertyGrid);

            DockPanel panel2 = panel1.AddPanel();

            panel2.Text = "Panel 2";

            ListBox listBox = new ListBox();

            listBox.Dock           = DockStyle.Fill;
            listBox.IntegralHeight = false;

            listBox.Items.AddRange(new string [] { "Item 1", "Item 2", "Item 3" });

            panel2.ControlContainer.Controls.Add(listBox);

            this.removeButton.Click += removeButton_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 패널 제거하기 버튼 클릭시 처리하기 - removeButton_Click(sender, e)

        /// <summary>
        /// 패널 제거하기 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void removeButton_Click(object sender, EventArgs e)
        {
            if(this.dockManager.Panels.Count > 0)
            {
                DockPanel panel = this.dockManager.Panels[0];

                this.dockManager.RemovePanel(panel);
            }
        }

        #endregion
    }
}